class BioLife extends BioMechanics {
  void OneLife() {
    double bestQuality=999.999e99;
   //organism building parameter
    BuildBinProbabilityTable();
    //ReportTime();

    for (int trial=1; trial<=TrialNumber; trial++) {
      System.out.println("*****************************************");
      System.out.println("* TRIAL " + trial);
      System.out.println("*****************************************");
      //Educate();
      Read(AgeBorn);
      int a=0;
      Age(a);
      InitializeCellPosition(trial);
      Explode(3.0);
      LocateBed(0.01);
      Write();
      System.out.println("////////////////////////////////////////////////////////////////////");
      System.out.println("//ACT ONE");
      do {
      	System.out.println("@STEP-10: cell placement, pad placement");
      	a++;
      	Age(a);
        CalculateArgument(a);
      	UpdateAllCells(CellNewRatio);
      	LocateBed(0.01);
        CalculateCompleteForce();
        CalculateCellPosition();
        CalculateSoftBoundaryTerminalPosition(0);
        Write();
      	System.out.println("@STEP-11: steiner placement");
        a++;
        Age(a);
      	LocateBed(0.01);
        CalculateCompleteForce();
        CalculateSteinerPosition();
        Write();
      } while (a<AgeYouth);
      System.out.println("////////////////////////////////////////////////////////////////////");
      System.out.println("//ACT TWO");
      do {
      	System.out.println("@STEP-20: cell placement, pad placement");
      	a++;
      	Age(a);
        CalculateArgument(a);
      	UpdateAllCells(CellNewRatio);
      	LocateBed(0.01);
        CalculateCompleteForce();
        CalculateCellPosition();
        CalculateSoftBoundaryTerminalPosition(0);
        Write();
      	System.out.println("@STEP-21: steiner placement");
        a++;
        Age(a);
      	LocateBed(0.01);
        CalculateCompleteForce();
        CalculateSteinerPosition();
        Write();
      	System.out.println("@STEP-22: soft-terminal placement and hard-cell orientation adjustment");
        a++;
        Age(a);
      	LocateBed(0.01);
        CalculateCompleteForce();
        CalculateSoftTerminalPosition();
        CalculateHardCellOrientation();
        Write();
      	System.out.println("@STEP-23: soft-cell reshaping");
        a++;
        Age(a);
      	LocateBed(0.01);
        CalculateCompleteForce();
        CalculateSoftCellShape();
        Write();
      } while (a<AgeAdult);
      System.out.println("////////////////////////////////////////////////////////////////////");
      System.out.println("//ACT THREE");
      do {
      	System.out.println("@STEP-30: cell placement, pad placement");
      	a++;
      	Age(a);
        CalculateArgument(a);
      	UpdateAllCells(CellNewRatio);
      	LocateBed(0.01);
        CalculateCompleteForce();
        CalculateCellPosition();
        CalculateSoftBoundaryTerminalPosition(0);
        Write();
      	System.out.println("@STEP-31: steiner placement");
        a++;
        Age(a);
      	LocateBed(0.01);
        CalculateCompleteForce();
        CalculateSteinerPosition();
        Write();
      	System.out.println("@STEP-32: soft-terminal placement");
        a++;
        Age(a);
      	LocateBed(0.01);
        CalculateCompleteForce();
        CalculateSoftTerminalPosition();
        Write();
      } while (a<AgeOld);
      a++;
      Age(a);
      Compaction2D();
      Write();
      System.out.println("////////////////////////////////////////////////////////////////////");
      System.out.println("//ACT FOUR");
      for (int i=1; i<=10; i++) {
      	System.out.println("@STEP-40: soft-terminal placement");
        a++;
        Age(a);
        LocateBed(0.01);
        CalculateCompleteForce();
        CalculateSoftBoundaryTerminalPosition();
        Write();
      	System.out.println("@STEP-41: pad placement");
      	a++;
      	Age(a);
        LocateBed(0.01);
        CalculateCompleteForce();
        CalculateSoftBoundaryTerminalPosition(0);
        Write();
      	System.out.println("@STEP-42: steiner placement");
        a++;
        Age(a);
        LocateBed(0.01);
        CalculateCompleteForce();
        CalculateSteinerPosition();
        Write();
      }
      LocateBed(0.01);
      ReportLayout();
      double quality=(double)TotalWireLength;
      if (quality<bestQuality) {
      	bestQuality=quality;
        Age(AgeDie);
        Write();
        System.out.println("*****************************************");
        System.out.println("* A BETTER RESULT FOUND AND SAVED. Area=" + ChipArea + " TWL=" + TotalWireLength);
        System.out.println("*****************************************");
      }
      else {
        System.out.println("*****************************************");
        System.out.println("* KEEP THE UP-TO-DATE BEST ONE. Area=" + ChipArea + " TWL=" + TotalWireLength);
        System.out.println("*****************************************");
      }
    }
    //pick the best one in terms of (1) "satisfy more constraints", (2) smaller area.
    //Statistic();
    //ReportTime();
  }

}
