import java.io.*;
import java.util.*;
import java.lang.Math;

class Useful {

  int INFINITY_INT=999999999;
  double INFINITY_DOUBLE=9.9E+100;

 //Useful String-Int, and String-Double transformation Function
  int StringToInt(String InString) {
    int CurrentPoint = 0; 
    int Value = 0;
    int Sign;
    if (InString.charAt(0)=='-') {
      Sign = -1;
      CurrentPoint ++;
    }
    else
      Sign = 1;
    while (CurrentPoint < InString.length()) {
      int currentDigit = (int)(InString.charAt(CurrentPoint) - '0');
      if ((currentDigit <= 9) & (currentDigit >= 0)) {
        Value = Value * 10 + currentDigit;
      }
      CurrentPoint ++;
    }
    return Value * Sign;
  }
    
  double StringToDouble(String InString) {
    int CurrentPoint=0; 
    double Value=0.0;
    int FractionDigitNumber=0;
    int Exp=0;
    boolean InData=true, InValueInt=true;
    int SignData=1, SignExp=1;
    while (CurrentPoint<InString.length()) {
      char c=InString.charAt(CurrentPoint);
      switch(c) {
        case '-': if (InData) SignData=-1; else SignExp=-1; break;
        case '+': break;
        case 'E':
        case 'e': InData=false; break;
        case '.': InValueInt=false; break;
        default : int d=c-'0';
                  if (d>9|d<0) {
                    System.out.println("Cannot recognize in StringToDouble at the " + CurrentPoint + "th Character " + c); 
                    for (;;); //die for error.
                  }
                  else {
                    if (InData) {
        	      double v=(double)(d);
        	      if (InValueInt) Value=Value*10+v;
        	      else { 
        	        FractionDigitNumber++;
        	        for (int i=1; i<=FractionDigitNumber; i++) v/=10;
                        Value+=v;
        	      }
        	    }
        	    else {  //in exponential part
        	      Exp=Exp*10+d;
        	    }
        	  }
        	  break;
      }
      CurrentPoint++;
    }
    //construct the value with exponential
    if (SignExp>0) for (int i=1; i<=Exp; i++) Value*=10;
    else           for (int i=1; i<=Exp; i++) Value/=10;
    return Value*SignData;
  }
  
  String DoubleToString(double value) {  //return a 10-digit string.
    String string = new String();
    int integerDigit;
    if (value < 0.0) { 
      string += '-';
      value = - value;
    }
    integerDigit = 0;
    while (value >= 1.0) {
      value /= 10.0;
      integerDigit ++;
    }
    for (int i=1; i<=integerDigit; i++) {
      value *= 10;
      string += (char)((int)value + '0');
      value -= (int)value;
    }
    string += '.';
    for (int i=1; i<=10-integerDigit; i++) {
      value *= 10;
      string += (char)((int)value + '0');
      value -= (int)value;
    }
    return string;
  }

  void WriteALineToFile(String LineField, OutputStream f) {
    try {
      for (int i=0; i<LineField.length(); i++) f.write((byte)LineField.charAt(i));
    }
    catch (IOException e) {
    }
  }
  
  double EuclideanDistanceSquare(int X0, int Y0, int X1, int Y1) {
    double x0=(double)X0, y0=(double)Y0, x1=(double)X1, y1=(double)Y1;
    return ((x0-x1)*(x0-x1)+(y0-y1)*(y0-y1));
  }

  int EuclideanDistance(int X0, int Y0, int X1, int Y1) {
    double x0=(double)X0, y0=(double)Y0, x1=(double)X1, y1=(double)Y1;
    return (int)(java.lang.Math.sqrt((x0-x1)*(x0-x1)+(y0-y1)*(y0-y1)));	
  }

}
